package eu.ztsh.lib.time.hazelcast;

import com.hazelcast.nio.serialization.ByteArraySerializer;
import eu.ztsh.lib.time.TimeRange;

import java.io.IOException;
import java.time.LocalDate;

import static eu.ztsh.lib.time.Formatters.yearMonthDay;

public class TimeRangeSerializer implements ByteArraySerializer<TimeRange> {

    @Override
    public byte[] write(TimeRange timeRange) throws IOException {
        return (yearMonthDay.format(timeRange.from()) + ":" + yearMonthDay.format(timeRange.to())).getBytes();
    }

    @Override
    public TimeRange read(byte[] bytes) throws IOException {
        var stringData = new String(bytes).split(":");
        return new TimeRange(parse(stringData[0]), parse(stringData[1]));
    }

    private static LocalDate parse(String input) {
        return LocalDate.parse(input, yearMonthDay);
    }

    @Override
    public int getTypeId() {
        return 150;
    }

}
